
TYPO3.TYPO3CR - Bug # 1620

Status: Resolved Priority: Must have
Author: Robert Lemke Category: FLOW3 Persistence
Created: 2008-10-01 Assigned To: Karsten Dambekalns
Updated: 2011-05-05 Due date:
Subject: Reference array keys are discarded during persistence without a warning
Description

@reference properties of type array (ie. references to other objects) are persisted - but only the values. The keys of this array are
discarded.  Either implement support for persisting these keys as well (would be very cool) or at least throw a warning in the meantime
if the array keys are something else than integers.

Associated revisions
Revision f172bffa - 2008-11-12 13:53 - Karsten Dambekalns
FLOW3, TYPO3CR:
    -  the persistence framework no longer needs the @reference annotation, fixes #1620
TYPO3:
    -  removed @reference annotations

Revision 61aa7621 - 2008-12-05 21:28 - Karsten Dambekalns
FLOW3, TYPO3CR:
    -  Persistence: rewrote the way object trees are stored in the CR, fixes #1883, fixes #1882
TYPO3CR:
    -  Persistence: array keys are now preserved when persisting, fixes #1620
    -  Persistence: fixed error when persisting DateTime properties, fixes #2195
    -  changed the way properties are added to the Lucene index, fixes #1623, refs #1886
    -  fixed storage backend to enable use of namespaced nodetype names
Lucene, TYPO3CR:
    -  moved the KeywordAnalyser here from TYPO3CR

History
#1 - 2008-10-28 12:58 - Karsten Dambekalns
- Priority changed from Should have to Must have
- Target version set to 1.0 alpha 1

#2 - 2008-11-11 12:22 - Karsten Dambekalns
- Status changed from New to Accepted

#3 - 2008-11-11 20:05 - Karsten Dambekalns

A warning is probably not be what people would like to see...

Anyway, JSR-283 (as well as JSR-170) only support array-like multi-valued properties, and arrays simply do not have "named keys" in Java; a
hashmap is used for that instead. Thus we need to store those "associative arrays" differently. One way could be:

N flow3:someobjectinstance [flow:]
  P name = cool
  P foo = bar
  P scores = [1, 3, 2, 6, 1, 1]
  N members [AssociativeMultiValuedProperty]
    P foo = bar
    P lame = duck
    P another = item

Legend: N = node, P = property, [something] = node type

for an object having two simple properties, one numerically indexed array and one associative array.

There is still an open question: what about numerically indexed arrays whose keys are "used", i.e. carry meaning? It is impossible to detect those, so
maybe we need another annotation (e.g. @preservekeys)?

#4 - 2008-11-12 09:19 - Robert Lemke

Karsten Dambekalns wrote:

There is still an open question: what about numerically indexed arrays whose keys are "used", i.e. carry meaning? It is impossible to detect those,
so maybe we need another annotation (e.g. @preservekeys)?

That's difficult ... If in doubt I would look at what the user would expect to happen: If she doesn't know about the special annotation, she would be
surprised to find out that all keys are gone.

BTW, interesting in this regard is also the planned SplFastArray: http://www.colder.ch/news/06-07-2008/33/splfastarray-to-speed-up-.html

#5 - 2008-11-12 11:53 - Karsten Dambekalns

If people would jump on the SplFastArray wagon, that would make life easier. We could store SplFastArray as simple multi-valued properties, and
regular arrays using the more complicated construct proposed above.

Still I would like to avoid using that construct more than needed, as it smells of performance loss. Hm, I guess I shoud try that and actually measure...

#6 - 2008-11-12 13:55 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r1500.

#7 - 2008-11-12 14:03 - Karsten Dambekalns
- Status changed from Resolved to Accepted
- % Done changed from 100 to 0

Used the wrong issue number in the commit message...
#8 - 2008-11-26 13:28 - Karsten Dambekalns
- Project changed from TYPO3.Flow to TYPO3.TYPO3CR
- Category deleted (Persistence)
- Target version deleted (1.0 alpha 1)

#9 - 2008-11-26 13:32 - Karsten Dambekalns
- Category set to FLOW3 Persistence
- Target version set to 197

#10 - 2008-11-26 15:12 - Karsten Dambekalns
- % Done changed from 0 to 70

Locally I have now implemented storing all arrays as nodes (of nodetype flow3:arrayProxyNode), this will solve the issue and make array keys "first
class citizens" again.

This will be committed into SVN as soon as the related changes for #1883 are stabilized.

#11 - 2008-11-26 17:39 - Karsten Dambekalns
- File Nodetree-from-objects.png added

#12 - 2008-12-05 21:30 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 70 to 100

Applied in changeset r1565.

#13 - 2011-05-05 17:12 - Robert Lemke
- Target version deleted (197)

Files
Nodetree-from-objects.png 43.1 kB 2008-11-26 Karsten Dambekalns
